From 8fbaea8dbb92be11ad5f6b43c8c4ec6e862ec5e9 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 31 2020 01:21:28 +0000
Subject: [PATCH 1899/2232] Fix span placement on shared enums


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index c355a9e..a29434f 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -314,15 +314,25 @@ fn expand_enum(enm: &Enum) -> TokenStream {
     let mut derives = None;
     let derived_traits = derive::expand_enum(enm, &mut derives);
 
+    let span = ident.span();
+    let visibility = enm.visibility;
+    let struct_token = Token![struct](enm.enum_token.span);
+    let enum_repr = quote! {
+        #[allow(missing_docs)]
+        pub repr: #repr,
+    };
+    let enum_def = quote_spanned! {span=>
+        #visibility #struct_token #ident {
+            #enum_repr
+        }
+    };
+
     quote! {
         #doc
         #attrs
         #derives
         #[repr(transparent)]
-        pub struct #ident {
-            #[allow(missing_docs)]
-            pub repr: #repr,
-        }
+        #enum_def
 
         #[allow(non_upper_case_globals)]
         impl #ident {
diff --git a/syntax/mod.rs b/syntax/mod.rs
index da21204..0d07fd0 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -98,6 +98,7 @@ pub struct Enum {
     pub doc: Doc,
     pub derives: Vec<Derive>,
     pub attrs: OtherAttrs,
+    pub visibility: Token![pub],
     pub enum_token: Token![enum],
     pub name: Pair,
     pub brace_token: Brace,
diff --git a/syntax/parse.rs b/syntax/parse.rs
index 5ce2cf3..b8bf515 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -194,6 +194,12 @@ fn parse_enum(cx: &mut Errors, item: ItemEnum, namespace: &Namespace) -> Result<
         }
     }
 
+    let visibility = Token![pub](match item.vis {
+        Visibility::Public(vis) => vis.pub_token.span,
+        Visibility::Crate(vis) => vis.crate_token.span,
+        Visibility::Restricted(vis) => vis.pub_token.span,
+        Visibility::Inherited => item.ident.span(),
+    });
     let enum_token = item.enum_token;
     let brace_token = item.brace_token;
 
@@ -216,6 +222,7 @@ fn parse_enum(cx: &mut Errors, item: ItemEnum, namespace: &Namespace) -> Result<
         doc,
         derives,
         attrs,
+        visibility,
         enum_token,
         name,
         brace_token,
diff --git a/tests/ui/deny_missing_docs.stderr b/tests/ui/deny_missing_docs.stderr
index f31be34..6feec4f 100644
--- a/tests/ui/deny_missing_docs.stderr
+++ b/tests/ui/deny_missing_docs.stderr
@@ -17,6 +17,12 @@ error: missing documentation for a struct field
    |         ^^^^^^^^^^^^^^^^^^^^^^^^^^
 
 error: missing documentation for a struct
+  --> $DIR/deny_missing_docs.rs:21:5
+   |
+21 |     pub enum UndocumentedEnum {
+   |     ^^^^^^^^^^^^^^^^^^^^^^^^^
+
+error: missing documentation for an associated constant
  --> $DIR/deny_missing_docs.rs:9:1
   |
 9 | #[cxx::bridge]
@@ -24,7 +30,7 @@ error: missing documentation for a struct
   |
   = note: this error originates in an attribute macro (in Nightly builds, run with -Z macro-backtrace for more info)
 
-error: missing documentation for an associated constant
+error: missing documentation for a struct
  --> $DIR/deny_missing_docs.rs:9:1
   |
 9 | #[cxx::bridge]
diff --git a/tests/ui/enum_match_without_wildcard.stderr b/tests/ui/enum_match_without_wildcard.stderr
index 85cc0c5..183aa5e 100644
--- a/tests/ui/enum_match_without_wildcard.stderr
+++ b/tests/ui/enum_match_without_wildcard.stderr
@@ -1,8 +1,8 @@
 error[E0004]: non-exhaustive patterns: `A { repr: 2_u8..=u8::MAX }` not covered
   --> $DIR/enum_match_without_wildcard.rs:12:11
    |
-1  | #[cxx::bridge]
-   | -------------- `ffi::A` defined here
+3  |     enum A {
+   |          - `ffi::A` defined here
 ...
 12 |     match a {
    |           ^ pattern `A { repr: 2_u8..=u8::MAX }` not covered

